'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : [select VIEW...EDITOR OPTIONS]                    *
'*  Notice  : Copyright (c) 2011 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 02.05.2011                                        *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
Device = 16F628A
Xtal = 4
;Config BOREN_OFF, CP_OFF, DATA_CP_OFF, PWRTE_ON, WDT_OFF, LVP_OFF, MCLRE_ON, INTRC_OSC_NOCLKOUT
@CONFIG_REQ
    @__CONFIG 3F30h
    
    Create_Coff = 1
    All_Digital = 1
    
    Declare  LCD_Type ALPHA       '   -  -
    Declare  LCD_DTPin  PORTB.4   '   
    Declare  LCD_ENPin  PORTB.3   '   E
    Declare  LCD_RSPin  PORTB.2   '   RS
    Declare  LCD_Interface  4     '   
    Declare  LCD_CommandUs  2000  '    
    Declare  LCD_DataUs  50       '    
    Declare  LCD_Lines   2        '   
'========================================================
'********       
'========================================================
    Symbol dq   = PORTA.0           '  
    Dim terme       As  Bit         '    
    Dim Temp_read   As  Word        '  
    Dim Sign        As  Byte        '  
    Dim TempC       As  Byte        ' 
    Dim TemperC     As  Word        ' ʳ 
    Dim Float0      As  Byte        ' 
    Dim Float1      As  Byte        ' 
    Dim C           As  Bit         ;  reset
    
    Dim command     As  Byte        ' Storage for command
    Dim i           As  Byte        ' Storage for loop counter

    Dim Reg_1 As Byte               ; 
    Dim Reg_2 As Byte               ; 
    Dim Reg_3 As Byte               ; 
;========================================================
    Dim Dig1 As Byte                   ; 1- 
    Dim Dig2 As Byte                   ; 2-
    Dim Dig3 As Byte                   ; 3-
    
    TRISA = %00000000
    TRISB = %00000000
    PORTA = 0
    PORTB = 0
    DelayMS 500 
    Print $FE,64,14,17,17,14,0,0,0,0
    Print $FE,64+8,$00,$00,$00,$00,$00,$00,$1F,$00 ' 0-
        Cls
    Print At 1,2, "Ivan_Fd Programm"
        DelayMS 1500
        Cls
        
main:
    GoSub temploop
    GoSub PreTemp

    Print At 1,4,$2D, $54, $65, $70, $BC, $6F, $4D, $65, $BF, $70, $2D
    
    If Dig1 = 0 Then
       Print At 2,1, $54, $65, $BC, $BE, $3A,Sign,Dec Dig2,".",Dec Dig3
       Print $FE,201,0,"   "
    Else
       Print At 2,1, $54, $65, $BC, $BE, $3A,Sign, Dec Dig1,Dec Dig2,".",Dec Dig3
       Print $FE,202,0
       
    EndIf

GoTo main


;===================================================================================
; *********************************************************************************                  
;                     䳿  
;                      
;                            DS18B20
; *********************************************************************************
;===================================================================================           
'========================================================================
'               
'========================================================================
temploop:
        GoSub init1820              ' Init the DS1820

        If terme = 0 Then Return

        OWrite dq,1,[$CC,$4E,0,0,%00011111]

        GoSub init1820              ' Init the DS1820

        OWrite dq,1,[$CC,$44]


        Repeat           	' 
        DelayMS 25 	        ' 
        ORead dq, 4, [C] 	'     
        Until C > 0 	    ' 1


        GoSub init1820            ' Do another init

        OWrite dq,1,[$CC,$BE]

        ORead dq, 2,[Temp_read.LowByte, Temp_read.HighByte]

        GoSub Temp_calc               '    
        ' Display the decimal temperature
Return



Temp_calc:                    '  
'******************************************************************************************************
    If Temp_read.11 = 1 Then  ' 
        Sign = "-"
        Temp_read = ~Temp_read + 1 
    Else
        Sign = "+"
    EndIf
    TempC  = (Temp_read & $0FF0) >> 4 
    Float1 = Temp_read.LowByte & $0F
    Float0 = LookUpL Float1, [0,1,1,2,2,3,4,4,5,6,6,7,7,8,9,9]
    TemperC = (TempC * 10) + Float0
    Return

;*********************************************************************
' Initialize DS1820 and check for presence
init1820:

        Low dq                  '  0  
        DelayUS 500             ' Wait > 480us
        Input dq                ' Release data pin (set to input for high)
        DelayUS 100             ' Wait > 60us
        If dq = 1 Then
             terme = 0
             Return             ' Try again
        EndIf
        terme = 1
        DelayUS 400             ' Wait for end of presence pulse
        Return



;===================================================================
;    
;===================================================================
        
PreTemp:           
    Dig3 = TemperC Dig 0
    Dig2 = TemperC Dig 1
    Dig1 = TemperC Dig 2
    Return
    
End
